classification
Title: importlib.machinery.ExtensionFileLoader cannot load several modules from the same shared object
Type: behavior Stage: resolved
Components: Extension Modules Versions: Python 3.4
process
Status: closed Resolution: fixed
Dependencies: Superseder:
Assigned To: asvetlov Nosy List: Arfrever, amaury.forgeotdarc, asvetlov, brett.cannon, docs@python, eric.snow, eudoxos, haypo, ncoghlan, pitrou, python-dev, r.david.murray
Priority: normal Keywords: patch

Created on 2012-11-06 14:42 by eudoxos, last changed 2012-12-15 16:28 by asvetlov. This issue is now closed.

Files
File name Uploaded Description Edit
many-modules-in-one-so_1.diff eudoxos, 2012-11-06 14:42 review
many-modules-in-one-so_2.diff eudoxos, 2012-11-06 15:54 Patch version 2, with tests review
many-modules-in-one-so_3.diff eudoxos, 2012-11-07 09:45 review
Messages (25)
msg174967 - (view) Author: Václav Šmilauer (eudoxos) * Date: 2012-11-06 14:42
This issue was split off issue16194 (I am not copying the whole discussion here). It was suggested a new issue is opened for Python3, where a proper fix can be done.

Python internally caches dynamically loaded modules, but the cache is based on the filename only. If one file contains several modules, only the first of them is imported and initialized properly. This interface was previously exposed via imp.load_dynamic, the same codepath is used by importlib.machinery.ExtensionFileLoader now.

A solution is to cache by the (filename, modulename) tuple, which avoids any ambiguity.

I am attaching a simple patch for that, agains current hg tip (80272:ec00f8570c55), and tested with the scripot attached to issue16194.

I have not modified the test suite, I am not sure whether testing compiled modules is actually supported (did not see any compiled files in there), I will be glad for help.
msg174970 - (view) Author: Andrew Svetlov (asvetlov) * (Python committer) Date: 2012-11-06 14:54
Storing several modules in single so/pyd file is crazy idea from my perspective.

The test is definitely required.

BTW, Why version is set to 3.5?
Should component be set to "Interpreter code"?
msg174971 - (view) Author: Amaury Forgeot d'Arc (amaury.forgeotdarc) * (Python committer) Date: 2012-11-06 14:59
It's not that crazy, if you consider that all builtin modules are stored in python33.dll.
msg174972 - (view) Author: Václav Šmilauer (eudoxos) * Date: 2012-11-06 14:59
Storing several modules in one .so file offloads some issues which have to be dealt with manually (like one module needing symbols from other module, or even cross-dependencies) to the linker. In any case, unless forbidden and signalled, it should be supported.

I set version to 3.4 and component to "Interpreter core", as you suggested, it is probably more appropriate.

How do I write test which requires a custom module to be compiled?
msg174975 - (view) Author: Andrew Svetlov (asvetlov) * (Python committer) Date: 2012-11-06 15:09
Amaury, I'm ok with pushing several modules into python33.dll or embedding it directly into executable. 
For standard so/dll files you have to use different file names for modules to make regular import statement work. It can be done via symlink/hardlink, but looks a bit hairy.

Václav, python already have _testbuffer and _testcapi modules used for testing only. I think you can add yet another one.
msg174976 - (view) Author: R. David Murray (r.david.murray) * (Python committer) Date: 2012-11-06 15:10
There is an example in the test suite somewhere.  Probably in the distutils tests.  Search for xxmodule...but you'll need to create your own source.  I'd see if you can write it out from the test rather than checking in another data file, but a data file is an option if needed.
msg174977 - (view) Author: Václav Šmilauer (eudoxos) * Date: 2012-11-06 15:12
@Andrew: I was using symlinks to achieve this, until I found recently that some exotic systems (read: windows) have still troubles there, like not letting non-admins create symlinks.
msg174981 - (view) Author: R. David Murray (r.david.murray) * (Python committer) Date: 2012-11-06 15:16
Sorry, didn't mean to change the component back.
msg174988 - (view) Author: Václav Šmilauer (eudoxos) * Date: 2012-11-06 15:54
I added the test, with a module Modules/_testimportmultiple.c.

The test uses the (undocumented) imp module, but all othet tests in Lib/test/test_imp.py do the same, so I assume it is OK?
msg174992 - (view) Author: Brett Cannon (brett.cannon) * (Python committer) Date: 2012-11-06 16:39
It's fine to cheat in tests, although test_imp predates importlib which is why it uses an undocumented API.
msg175004 - (view) Author: Andrew Svetlov (asvetlov) * (Python committer) Date: 2012-11-06 19:52
Reviewed and commented the last patch.
msg175059 - (view) Author: Václav Šmilauer (eudoxos) * Date: 2012-11-07 09:45
Attaching patch based on Andrew's review, agains latest hg (80291:859ef54bdce).

For the MSVC files, I copied what was there for _testcapimodule in PC/VS9.0 and PCbuild, and created two new UUIDs: one for _testimportmultiple itself (36D0C52C-DF4E-45D0-8BC7-E294C3ABC781; used in .sln, .vcproj and .vcxproj files), and one for _testimportmultiple.vcxproj.filters (1ec38ad9-1abf-4b80-8628-ac43ccba324b; used only once).

Please check that I did that correctly. (I am wondering how can one maintain such a build system.)

I also added myself to Misc/ACKS (and sent contributor agreement by mail), added the entry to Misc/NEWS.
msg175087 - (view) Author: Andrew Svetlov (asvetlov) * (Python committer) Date: 2012-11-07 11:57
Looks better, will check on Windows a bit later.

BTW, ACKS and NEWS are usually edited by committer, but leave that as is for now.
msg175090 - (view) Author: Václav Šmilauer (eudoxos) * Date: 2012-11-07 12:12
Good, will let editors do that next time.

I was following http://docs.python.org/devguide/patch.html#preparation which says "Sixth, if you are not already in the Misc/ACKS file then add your name."

For NEWS, I was reading http://docs.python.org/devguide/committing.html#news-entries, but it is true it talks about commits, not about patches.
msg175103 - (view) Author: Nick Coghlan (ncoghlan) * (Python committer) Date: 2012-11-07 13:48
Yeah, ACKS is fine (we just don't mind doing it if the submitter leaves it out). Updating NEWS is less useful because it almost inevitably causes a conflict when the patch is applied. (We occasionally mutter about adopting a less conflict-prone approach to handling NEWS entries, but nobody has ever found it annoying enough to design a solution and officially propose switching to it)
msg175124 - (view) Author: Andrew Svetlov (asvetlov) * (Python committer) Date: 2012-11-07 21:29
Václav, your patch passed on Windows.
Will commit it after double check. 
Thanks.
msg176654 - (view) Author: Nick Coghlan (ncoghlan) * (Python committer) Date: 2012-11-29 15:15
One nice feature of this is the potential to simplify single-file distribution - pack your application into a zip file, and only need to extract a single shared library for *all* your extension modules, which could be handled via a utility function called in __main__.py rather than needing to be built into the interpreter.
msg176662 - (view) Author: Brett Cannon (brett.cannon) * (Python committer) Date: 2012-11-29 16:55
Are you still planning on committing this, Andrew?
msg177461 - (view) Author: Roundup Robot (python-dev) Date: 2012-12-14 15:05
New changeset 6eefe4d537b3 by Andrew Svetlov in branch 'default':
Issue #16421: allow to load multiple modules from the same shared object.
http://hg.python.org/cpython/rev/6eefe4d537b3
msg177462 - (view) Author: Andrew Svetlov (asvetlov) * (Python committer) Date: 2012-12-14 15:06
Committed. Sorry for delay.
Thanks, Vaclav!
msg177466 - (view) Author: STINNER Victor (haypo) * (Python committer) Date: 2012-12-14 16:42
Some tests are failing since the changeset 6eefe4d537b3.

Example:
http://buildbot.python.org/all/builders/x86%20RHEL%206%203.x/builds/1431/steps/test/logs/stdio

Please check buildbots.

[176/371] test_pkgutil
test_getdata_filesys (test.test_pkgutil.PkgutilTests) ... ok
test_getdata_zipfile (test.test_pkgutil.PkgutilTests) ... ok
test_unreadable_dir_on_syspath (test.test_pkgutil.PkgutilTests) ... ok
test_alreadyloaded (test.test_pkgutil.PkgutilPEP302Tests) ... ERROR
test_getdata_pep302 (test.test_pkgutil.PkgutilPEP302Tests) ... ERROR
test_mixed_namespace (test.test_pkgutil.ExtendPathTests) ... ERROR
test_simple (test.test_pkgutil.ExtendPathTests) ... ERROR
test_nested (test.test_pkgutil.NestedNamespacePackageTest) ... ok
test_get_importer_avoids_emulation (test.test_pkgutil.ImportlibMigrationTests) ... ok
test_get_loader_avoids_emulation (test.test_pkgutil.ImportlibMigrationTests) ... ok
test_importer_deprecated (test.test_pkgutil.ImportlibMigrationTests) ... ok
test_iter_importers_avoids_emulation (test.test_pkgutil.ImportlibMigrationTests) ... ok
test_loader_deprecated (test.test_pkgutil.ImportlibMigrationTests) ... ok

======================================================================
ERROR: test_alreadyloaded (test.test_pkgutil.PkgutilPEP302Tests)
----------------------------------------------------------------------
Traceback (most recent call last):
  File "/home/buildbot/buildarea/3.x.coghlan-redhat/build/Lib/test/test_pkgutil.py", line 139, in test_alreadyloaded
    self.assertEqual(foo.loads, 1)
AttributeError: 'module' object has no attribute 'loads'

======================================================================
ERROR: test_getdata_pep302 (test.test_pkgutil.PkgutilPEP302Tests)
----------------------------------------------------------------------
Traceback (most recent call last):
  File "/home/buildbot/buildarea/3.x.coghlan-redhat/build/Lib/pkgutil.py", line 502, in find_loader
    return importlib.find_loader(fullname, path)
  File "/home/buildbot/buildarea/3.x.coghlan-redhat/build/Lib/importlib/__init__.py", line 64, in find_loader
    loader = sys.modules[name].__loader__
AttributeError: 'module' object has no attribute '__loader__'

The above exception was the direct cause of the following exception:

Traceback (most recent call last):
  File "/home/buildbot/buildarea/3.x.coghlan-redhat/build/Lib/test/test_pkgutil.py", line 131, in test_getdata_pep302
    self.assertEqual(pkgutil.get_data('foo', 'dummy'), "Hello, world!")
  File "/home/buildbot/buildarea/3.x.coghlan-redhat/build/Lib/pkgutil.py", line 625, in get_data
    loader = get_loader(package)
  File "/home/buildbot/buildarea/3.x.coghlan-redhat/build/Lib/pkgutil.py", line 480, in get_loader
    return find_loader(fullname)
  File "/home/buildbot/buildarea/3.x.coghlan-redhat/build/Lib/pkgutil.py", line 508, in find_loader
    raise ImportError(msg.format(fullname, type(ex), ex)) from ex
ImportError: Error while finding loader for 'foo' (<class 'AttributeError'>: 'module' object has no attribute '__loader__')

======================================================================
ERROR: test_mixed_namespace (test.test_pkgutil.ExtendPathTests)
----------------------------------------------------------------------
Traceback (most recent call last):
  File "<frozen importlib._bootstrap>", line 1523, in _find_and_load_unlocked
AttributeError: 'module' object has no attribute '__path__'

During handling of the above exception, another exception occurred:

Traceback (most recent call last):
  File "/home/buildbot/buildarea/3.x.coghlan-redhat/build/Lib/test/test_pkgutil.py", line 198, in test_mixed_namespace
    import foo.bar
ImportError: No module named 'foo.bar'; foo is not a package

======================================================================
ERROR: test_simple (test.test_pkgutil.ExtendPathTests)
----------------------------------------------------------------------
Traceback (most recent call last):
  File "<frozen importlib._bootstrap>", line 1523, in _find_and_load_unlocked
AttributeError: 'module' object has no attribute '__path__'

During handling of the above exception, another exception occurred:

Traceback (most recent call last):
  File "/home/buildbot/buildarea/3.x.coghlan-redhat/build/Lib/test/test_pkgutil.py", line 170, in test_simple
    import foo.bar
ImportError: No module named 'foo.bar'; foo is not a package

----------------------------------------------------------------------
Ran 13 tests in 0.027s
msg177535 - (view) Author: Antoine Pitrou (pitrou) * (Python committer) Date: 2012-12-15 14:46
Indeed it looks like this commit may be the culprit for numerous buildbot failures.
msg177536 - (view) Author: Antoine Pitrou (pitrou) * (Python committer) Date: 2012-12-15 14:48
Naming the test modules "foo" and "bar" was perhaps not the best idea.
msg177537 - (view) Author: Roundup Robot (python-dev) Date: 2012-12-15 15:23
New changeset 2e492a9a1845 by Andrew Svetlov in branch 'default':
Rename test module names for #16421 to don't clash with other tests.
http://hg.python.org/cpython/rev/2e492a9a1845
msg177538 - (view) Author: Andrew Svetlov (asvetlov) * (Python committer) Date: 2012-12-15 16:28
Fixed.
Antoine, you are right: foo and bar was bad names.
History
Date User Action Args
2013-02-01 22:33:11brett.cannonlinkissue14724 superseder
2012-12-15 16:28:40asvetlovsetstatus: open -> closed
resolution: fixed
messages: + msg177538
2012-12-15 15:23:10python-devsetmessages: + msg177537
2012-12-15 14:48:16pitrousetmessages: + msg177536
2012-12-15 14:46:41pitrousetnosy: + pitrou
messages: + msg177535
2012-12-14 16:42:11hayposetstatus: closed -> open

nosy: + haypo
messages: + msg177466

resolution: fixed -> (no value)
2012-12-14 15:06:23asvetlovsetstatus: open -> closed
resolution: fixed
messages: + msg177462

stage: resolved
2012-12-14 15:05:09python-devsetnosy: + python-dev
messages: + msg177461
2012-11-29 16:55:23brett.cannonsetmessages: + msg176662
2012-11-29 15:15:26ncoghlansetmessages: + msg176654
2012-11-13 03:02:02eric.snowsetnosy: + eric.snow
2012-11-07 21:29:12asvetlovsetassignee: asvetlov
messages: + msg175124
2012-11-07 13:48:41ncoghlansetmessages: + msg175103
2012-11-07 12:12:05eudoxossetmessages: + msg175090
2012-11-07 11:57:03asvetlovsetmessages: + msg175087
versions: + Python 3.4, - Python 3.5
2012-11-07 09:45:18eudoxossetfiles: + many-modules-in-one-so_3.diff
versions: + Python 3.5, - Python 3.4
messages: + msg175059

components: + Extension Modules, - Interpreter Core
type: enhancement -> behavior
2012-11-06 19:52:47asvetlovsetmessages: + msg175004
2012-11-06 16:39:44brett.cannonsetmessages: + msg174992
2012-11-06 15:54:13eudoxossetfiles: + many-modules-in-one-so_2.diff

messages: + msg174988
2012-11-06 15:16:53r.david.murraysettype: behavior -> enhancement
messages: + msg174981
components: + Interpreter Core, - Extension Modules
versions: + Python 3.4, - Python 3.5
2012-11-06 15:12:03eudoxossettype: enhancement -> behavior
messages: + msg174977
versions: + Python 3.5, - Python 3.4
2012-11-06 15:10:40r.david.murraysettype: behavior -> enhancement
messages: + msg174976
components: + Extension Modules, - Interpreter Core
2012-11-06 15:09:30asvetlovsetmessages: + msg174975
2012-11-06 15:08:11eudoxossetcomponents: + Interpreter Core, - Extension Modules
versions: + Python 3.4, - Python 3.5
2012-11-06 14:59:58eudoxossetmessages: + msg174972
2012-11-06 14:59:06amaury.forgeotdarcsetmessages: + msg174971
2012-11-06 14:54:36asvetlovsetnosy: + asvetlov
messages: + msg174970
2012-11-06 14:42:53eudoxoscreate